#include <linux/module.h>
#include <linux/fs.h>

static int device_open(struct inode *inp, struct file *filp)
{
	return 0;
}

static ssize_t device_read(struct file *filp, char *buf, size_t length, loff_t *f_pos)
{
	return 0;
}

static ssize_t device_write(struct file *filp, const char *buf, size_t length, loff_t *f_pos)
{
	printk( "received: %c%c\n",buf[0], buf[1]);
	return 2; 
}

static int device_release(struct inode *inp, struct file *filp)
{
	return 0;
}

static struct file_operations fops = {
	open: device_open,
	read: device_read,
	write: device_write,
	release: device_release
};

//////////////////////////////////////////////////////////////
static int MajorNumber = 0;

int init_module ( void ) 
{ 
	printk ("mindev loaded!\n");

	MajorNumber = register_chrdev(0, "mydevice", &fops);
	if( MajorNumber < 0 )
	{
		printk ("Registering mydevice failed.\n");
		return MajorNumber;
	}
	else
	{
		printk ("create a device: 'mknod /dev/mydevice c %d 0'.\n",MajorNumber);
	}
	return 0;
}

void cleanup_module( void )
{ 
	unregister_chrdev(MajorNumber, "mydevice");
	printk ("mindev unloaded.\n");
}

MODULE_AUTHOR("gg");
MODULE_LICENSE("GPL");
