#include <linux/module.h>
#include <linux/mm.h>
#include <linux/sched.h>

/* WARNING: This module will crash your Kernel */

int init_module ( void ) 
{ 
	int* badarray, *funcptr, *tmpptr;
	int i;
	printk ("Bad Kernel Module\n");
	badarray = (int*) kmalloc(100, GFP_KERNEL);
	if(!badarray) {
		printk(KERN_WARNING "no more memory :(\n");
		return 0;
	}

/*	funcptr = (int*) &do_gettimeofday; 	*/
	funcptr = (int*) &schedule; 	
	printk("0x%08x function\n", (int)funcptr);


	tmpptr = badarray; /* save old ptr */
	badarray = funcptr; /* bad new ptr */
	for(i=0; i<1; ++i) badarray[i] = 0xfea1dead;

	
	badarray = tmpptr;
	kfree(badarray);
	return 0;
}

void cleanup_module( void )
{ 
	printk ("Goodbye Kernel.\n");
}

MODULE_AUTHOR("gg");
MODULE_LICENSE("GPL");
